// Generated by gmmproc 2.66.7 -- DO NOT MODIFY!
#ifndef _GOOCANVASMM_TEXT_H
#define _GOOCANVASMM_TEXT_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasmm/itemsimple.h>
#include <gtkmm/enums.h> /* For AnchorType. */
#include <pangomm/rectangle.h>
#include <pangomm/layout.h> //For Pango::Alignment


#ifndef DOXYGEN_SHOULD_SKIP_THIS
using GooCanvasText = struct _GooCanvasText;
using GooCanvasTextClass = struct _GooCanvasTextClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Goocanvas
{ class  Text_Class; } // namespace Goocanvas
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Goocanvas
{


class Text : public Goocanvas::ItemSimple
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  using CppObjectType = Text;
  using CppClassType = Text_Class;
  using BaseObjectType = GooCanvasText;
  using BaseClassType = GooCanvasTextClass;

  // noncopyable
  Text(const Text&) = delete;
  Text& operator=(const Text&) = delete;

private:  friend class Text_Class;
  static CppClassType text_class_;

protected:
  explicit Text(const Glib::ConstructParams& construct_params);
  explicit Text(GooCanvasText* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  Text(Text&& src) noexcept;
  Text& operator=(Text&& src) noexcept;

  ~Text() noexcept override;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GooCanvasText*       gobj()       { return reinterpret_cast<GooCanvasText*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GooCanvasText* gobj() const { return reinterpret_cast<GooCanvasText*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GooCanvasText* gobj_copy();

private:

protected:

  explicit Text(const Glib::ustring& text = Glib::ustring(), double x = 0.0, double y = 0.0, double width = -1, AnchorType anchor = ANCHOR_NORTH_WEST);
  

public:

  
  static Glib::RefPtr<Text> create(const Glib::ustring& text =  Glib::ustring(), double x =  0.0, double y =  0.0, double width =  0.0, AnchorType anchor =  ANCHOR_NORTH_WEST);


  /** Gets the natural extents of the text, in the text item's coordinate space.
   * 
   * The final extents of the text may be different, if the text item is placed
   * in a layout container such as Goo::CanvasTable.
   * 
   * @param ink_rect The location to return the ink rect, or <tt>nullptr</tt>.
   * @param logical_rect The location to return the logical rect, or <tt>nullptr</tt>.
   */
  void get_natural_extents(Pango::Rectangle& ink_rect, Pango::Rectangle& logical_rect) const;

  //We put these in item.hg instead.
  //See the comment there.
  //_WRAP_PROPERTY("x", double)
  //_WRAP_PROPERTY("y", double)
  //_WRAP_PROPERTY("width", double)
  //_WRAP_PROPERTY("height", double)
  /** How to align the text.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Pango::Alignment > property_alignment() ;

/** How to align the text.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Pango::Alignment > property_alignment() const;

  /** How to position the text relative to the given x and y coordinates.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< AnchorType > property_anchor() ;

/** How to position the text relative to the given x and y coordinates.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< AnchorType > property_anchor() const;

  /** The preferred place to ellipsize the string, if the label does not have enough room to display the entire string.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Pango::EllipsizeMode > property_ellipsize() ;

/** The preferred place to ellipsize the string, if the label does not have enough room to display the entire string.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Pango::EllipsizeMode > property_ellipsize() const;

  /** The text to display.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Glib::ustring > property_text() ;

/** The text to display.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::ustring > property_text() const;

  /** Whether to parse PangoMarkup in the text, to support different styles.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_use_markup() ;

/** Whether to parse PangoMarkup in the text, to support different styles.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_use_markup() const;

  /** The preferred method of wrapping the string if a width has been set.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Pango::WrapMode > property_wrap() ;

/** The preferred method of wrapping the string if a width has been set.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Pango::WrapMode > property_wrap() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} //namespace Goocanvas


namespace Glib
{
  /** A Glib::wrap() method for this object.
   *
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Goocanvas::Text
   */
  
  Glib::RefPtr<Goocanvas::Text> wrap(GooCanvasText* object, bool take_copy = false);
}


#endif /* _GOOCANVASMM_TEXT_H */

